#include "level.h"
#include "stdlib.h"

Level* level_load(int n)
{
	Level* level = NULL;
	if(n == 0) {
		const char road[] = {
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			TREE, HOUSE, HOUSE, EMPTY, HOUSE, TREE,
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY
		};
		const char sky[] = {-1, 2, -1, -1, 2, -1, -1, -1, -1, 1, 1, -1, 2, -1, -1, -1, -1, -1, -1, -1};
		level = level_create(CITY, road, sky, 6+14);
	} else if(n == 1) {
		const char road[] = {
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			TREE, TREE, TREE, TREE, TREE, TREE,
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY
		};
		const char sky[] = {-1, -1, -1, -1, -1, -1, -1, 0, 0, -1, -1, -1, 3, 4, -1, -1, -1, -1, -1, -1};
		level = level_create(COUNTRY, road, sky, 6+14);
	} else if(n == 2) {
		const char road[] = {
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			HOUSE, HOUSE, HOUSE, TREE, EMPTY, EMPTY, EMPTY, TREE, HOUSE, HOUSE, HOUSE, HOUSE, TREE,
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY
		};
		const char sky[] = {-1, -1, -1, -1, -1, -1, -1, 0, -1, -1, -1, -1, -1, 0, 0, -1, -1, -1, -1, 4, 4, -1, -1, -1, -1, -1, -1};
		level = level_create(CITY, road, sky, 13+14);
	} else if(n == 3) {
		const char road[] = {
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			TREE, TREE, TREE, EMPTY, TREE, EMPTY, TREE, TREE, TREE,
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY
		};
		const char sky[] = {-1, -1, -1, -1, -1, -1, 0, 0, -1, -1, -1, -1, -1, 4, 4, -1, 0, -1, -1, -1};
		level = level_create(COUNTRY, road, sky, 9+14);
	} else if(n == 4) {
		const char road[] = {
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			TREE, HOUSE, TREE, EMPTY, TREE, HOUSE, TREE, EMPTY, TREE, HOUSE, TREE, EMPTY, TREE, HOUSE, TREE, EMPTY, HOUSE, HOUSE, HOUSE,
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY
		};
		const char sky[] = {-1, -1, -1, -1, -1, -1, -1, 0, 0, -1, -1, -1, 0, 0, -1, -1, -1, -1, -1, 0, 0, -1, 3, -1, -1, -1, 4, 4, -1, -1, -1, -1, -1};
		level = level_create(CITY, road, sky, 19+14);
	} else if(n == 5) {
		const char road[] = {
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			EMPTY, TREE, TREE, EMPTY, EMPTY, EMPTY, HOUSE, EMPTY, EMPTY, TREE, TREE, EMPTY, EMPTY, EMPTY,
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY
		};
		const char sky[] = {-1, -1, -1, -1, -1, -1, -1, 4, 3, 2, 2, 2, -1, -1, -1, 0, 1, 2, -1, -1, 4, 3, -1, -1, -1, -1, -1, -1};
		level = level_create(COUNTRY, road, sky, 14+14);
	} else if(n == 6) {
		const char road[] = {
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			HOUSE, HOUSE, HOUSE, HOUSE, HOUSE, HOUSE, EMPTY, TREE, TREE, EMPTY, HOUSE, HOUSE, HOUSE, HOUSE, HOUSE, HOUSE,
			EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY
		};
		const char sky[] = {-1, -1, -1, -1, -1, 0, 1, 2, 3, 3, -1, -1, -1, -1, 4, 4, -1, -1, 1, 2, 3, 3, 2, -1, -1, -1, -1, -1, -1, -1};
		level = level_create(CITY, road, sky, 16+14);
	}

	return level;
}

void level_free(Level* level)
{
	if(level) {
		if(level->road) free(level->road);
		if(level->sky) free(level->sky);
		free(level);
		level = NULL;
	}
}

Level* level_create(Level_type type, char* road, char* sky, int length)
{
	Level* level;
	int i;
	level = malloc(sizeof(Level));
	if(!level) return NULL;
	level->road = malloc(length);
	level->sky = malloc(length);
	if(!level->road || !level->sky) {
		level_free(level);
		return NULL;
	}
	level->type = type;
	level->length = length;
	level->nb_house = 0;
	for(i=0 ; i<length ; i++) {
		if(road[i] == HOUSE) level->nb_house++;
	}
	memcpy(level->road, road, length);
	memcpy(level->sky, sky, length);

	return level;
}
