#ifndef _TILESET
#define _TILESET

typedef enum {
	REINDEER_RIGHT, REINDEER_LEFT,
	SLEIGH_RIGHT, SLEIGH_LEFT,
	GIFT,
	CLOUD, ROAD, T_HOUSE, T_TREE,
	GAMEOVER
} Tileset_name;

typedef struct {
	int width, height, length;
	char** tile;
} Tileset;

/* public functions */
Tileset* tileset_load (Tileset_name name);
void tileset_free(Tileset* tileset);

/* private functions */
static Tileset* tileset_create (const char* bmp, int width, int height, int length);
static void tileset_horizontal_symmetry(Tileset* tileset);
static void tileset_vertical_symmetry(Tileset* tileset);
static void tileset_rotation_90_degrees(Tileset* tileset);
#endif

